---
comments: true
---

# 1.2. &nbsp; 算法是什么

## 1.2.1. &nbsp; 算法定义

「算法 Algorithm」是在有限时间内解决特定问题的一组指令或操作步骤。它具有以下特性：

- 问题是明确的，包含清晰的输入和输出定义。
- 具有可行性，能够在有限步骤、时间和内存空间下完成。
- 各步骤都有确定的含义，相同的输入和运行条件下，输出始终相同。

## 1.2.2. &nbsp; 数据结构定义

「数据结构 Data Structure」是计算机中组织和存储数据的方式。它的设计目标包括：

- 空间占用尽量减少，节省计算机内存。
- 数据操作尽可能快速，涵盖数据访问、添加、删除、更新等。
- 提供简洁的数据表示和逻辑信息，以便使得算法高效运行。

**数据结构设计是一个充满权衡的过程**。如果想要在某方面取得提升，往往需要在另一方面作出妥协，例如：

- 链表相较于数组，在数据添加和删除操作上更加便捷，但牺牲了数据访问速度。
- 图相较于链表，提供了更丰富的逻辑信息，但需要占用更大的内存空间。

## 1.2.3. &nbsp; 数据结构与算法的关系

数据结构与算法高度相关、紧密结合，具体表现在：

- 数据结构是算法的基石。数据结构为算法提供了结构化存储的数据，以及用于操作数据的方法。
- 算法是数据结构发挥的舞台。数据结构本身仅存储数据信息，通过结合算法才能解决特定问题。
- 特定算法通常有对应最优的数据结构。算法通常可以基于不同的数据结构进行实现，但最终执行效率可能相差很大。

![数据结构与算法的关系](what_is_dsa.assets/relationship_between_data_structure_and_algorithm.png)

<p align="center"> Fig. 数据结构与算法的关系 </p>

数据结构与算法犹如拼装积木。一套积木，除了包含许多零件之外，还附有详细的组装说明书。我们按照说明书一步步操作，就能组装出精美的积木模型。

![拼装积木](what_is_dsa.assets/assembling_blocks.jpg)

<p align="center"> Fig. 拼装积木 </p>

两者的详细对应关系如下表所示。

<div class="center-table" markdown>

| 数据结构与算法 | LEGO 乐高                                |
| -------------- | ---------------------------------------- |
| 输入数据       | 未拼装的积木                             |
| 数据结构       | 积木组织形式，包括形状、大小、连接方式等 |
| 算法           | 把积木拼成目标形态的一系列操作步骤       |
| 输出数据       | 积木模型                                 |

</div>

值得说明的是，数据结构与算法是独立于编程语言的。正因如此，本书得以提供多种编程语言的实现。

!!! tip "约定俗成的简称"

    在实际讨论时，我们通常会将「数据结构与算法」简称为「算法」。比如众所周知的 LeetCode 算法题目，实际上同时考察了数据结构和算法两方面的知识。
